#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum UnavailableResultConfigurationReason {
    #[serde(rename = "APPENDS_NOT_SUPPORTED_FOR_COMPUTE")]
    AppendsNotSupportedForCompute,
    #[serde(rename = "TOO_MANY_POINTS_FOR_UNDECIMATED_APPENDS")]
    TooManyPointsForUndecimatedAppends,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl UnavailableResultConfigurationReason {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            UnavailableResultConfigurationReason::AppendsNotSupportedForCompute => {
                "APPENDS_NOT_SUPPORTED_FOR_COMPUTE"
            }
            UnavailableResultConfigurationReason::TooManyPointsForUndecimatedAppends => {
                "TOO_MANY_POINTS_FOR_UNDECIMATED_APPENDS"
            }
            UnavailableResultConfigurationReason::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for UnavailableResultConfigurationReason {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for UnavailableResultConfigurationReason {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for UnavailableResultConfigurationReason {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<
        UnavailableResultConfigurationReason,
        conjure_object::plain::ParseEnumError,
    > {
        match v {
            "APPENDS_NOT_SUPPORTED_FOR_COMPUTE" => {
                Ok(UnavailableResultConfigurationReason::AppendsNotSupportedForCompute)
            }
            "TOO_MANY_POINTS_FOR_UNDECIMATED_APPENDS" => {
                Ok(
                    UnavailableResultConfigurationReason::TooManyPointsForUndecimatedAppends,
                )
            }
            v => {
                v.parse()
                    .map(|v| UnavailableResultConfigurationReason::Unknown(Unknown(v)))
            }
        }
    }
}
impl conjure_object::FromPlain for UnavailableResultConfigurationReason {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<
        UnavailableResultConfigurationReason,
        conjure_object::plain::ParseEnumError,
    > {
        v.parse()
    }
}
///An unknown variant of the UnavailableResultConfigurationReason enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
